using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Syncfusion.SfDataGrid;
using Android.Graphics;
using System.IO;
using System.Reflection;

namespace SelectionSample
{
    class CustomCell:GridCell
    {
        private ImageView customerImage;
        Bitmap bitmap;
        public CustomCell (Context context) : base (context)
		{
            customerImage = new ImageView(context);
			this.CanRenderUnLoad = false;
            this.AddView(customerImage);
		}

        public MemoryStream LoadResource(String name)
        {
            MemoryStream aMem = new MemoryStream();
            var assm = Assembly.GetExecutingAssembly();
            var path = String.Format("DataGrid.Resources.drawable.{0}", name);
            var aStream = assm.GetManifestResourceStream(path);
            aStream.CopyTo(aMem);
            return aMem;
        }

        protected override void UnLoad()
        {
            if (this.Parent != null)
                (this.Parent as VirtualizingCellsControl).RemoveView(this);
        }

        protected override void OnLayout(bool changed, int left, int top, int right, int bottom)
        {
            customerImage.Layout(0, 5, this.Width, this.Height - 5);
        }

        public override void Draw(Canvas canvas)
        {
            base.Draw(canvas);
            bitmap = (Bitmap)DataColumn.RowData.GetType().GetProperty("CustomerImage").GetValue(DataColumn.RowData);
            customerImage.SetImageBitmap(bitmap);
        }

        protected override void Dispose(bool disposing)
        {
            if (bitmap != null)
            {
                this.customerImage.Dispose();
                this.customerImage = null;
            }
            base.Dispose(disposing);
        }
    }
}