﻿using System;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Syncfusion.SfDataGrid;

namespace SelectionSample
{
    [Activity(Label = "SelectionSample", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        SfDataGrid dataGrid;
        ViewModel viewModel;
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);
            viewModel = new ViewModel();
            dataGrid = new SfDataGrid(this);
            dataGrid.ColumnSizer = ColumnSizer.Star;
            dataGrid.AutoGenerateColumns = false;
            dataGrid.ItemsSource = viewModel.ProductDetails;
            dataGrid.GridTapped += dataGrid_GridTapped;
            dataGrid.RowHeight = 70;

            dataGrid.Columns.Add(new GridTextColumn()
            {
                HeaderTextAlignment = GravityFlags.Center,
                UserCellType = typeof(CustomCell),
                MappingName = "CustomerImage",
                HeaderText = "Image",
                TextAlignment = GravityFlags.Center,
            });

            dataGrid.Columns.Add(new GridTextColumn()
            {
                HeaderTextAlignment = GravityFlags.Center,
                MappingName = "ProductID",
                HeaderText = "Product ID",
                TextAlignment =GravityFlags.Center,
            });
           
            dataGrid.Columns.Add(new GridTextColumn() 
            { 
                MappingName = "ProductModel",
                HeaderText = "Product Model",
                HeaderTextAlignment=GravityFlags.Center,
                TextAlignment=GravityFlags.Center,
            });

            dataGrid.Columns.Add(new GridTextColumn() 
            { 
                MappingName = "Price", 
                HeaderTextAlignment = GravityFlags.Center,
                TextAlignment = GravityFlags.Center
            });
            
            SetContentView(dataGrid);
        }

        void dataGrid_GridTapped(object sender, GridTappedEventsArgs e)
        {
            if(e.RowColumnindex.ColumnIndex==0)
            {
                Android.Net.Uri uri;
                if (e.RowColumnindex.RowIndex % 2 == 0)
                    uri = Android.Net.Uri.Parse("http://www.syncfusion.com/products/xamarin-android/datagrid");
                else
                    uri = Android.Net.Uri.Parse("http://www.syncfusion.com");
                var intent = new Intent(Intent.ActionView, uri); 
                StartActivity(intent);
            }
        }
    }
}

